# This file was generated by liblab | https://liblab.com/

from enum import Enum
from .utils.json_map import JsonMap
from .base import BaseModel


class CreatePeopleTimeoffType(Enum):
    """An enumeration representing different categories.

    :cvar VACATION: "VACATION"
    :vartype VACATION: str
    :cvar SICK_LEAVE: "SICK_LEAVE"
    :vartype SICK_LEAVE: str
    :cvar OTHER: "OTHER"
    :vartype OTHER: str
    """

    VACATION = "VACATION"
    SICK_LEAVE = "SICK_LEAVE"
    OTHER = "OTHER"

    def list():
        """Lists all category values.

        :return: A list of all category values.
        :rtype: list
        """
        return list(
            map(lambda x: x.value, CreatePeopleTimeoffType._member_map_.values())
        )


@JsonMap({"type_": "type"})
class CreatePeopleTimeoff(BaseModel):
    """CreatePeopleTimeoff

    :param type_: Time off type.
    :type type_: CreatePeopleTimeoffType
    :param start_date: Start date of employee's time off.
    :type start_date: str
    :param end_date: End date of employee's time off.
    :type end_date: str
    :param reason: Description for employee's time off.
    :type reason: str
    :param attachments: Attachments for employee's time off., defaults to None
    :type attachments: str, optional
    """

    def __init__(
        self,
        type_: CreatePeopleTimeoffType,
        start_date: str,
        end_date: str,
        reason: str,
        attachments: str = None,
    ):
        self.type_ = self._enum_matching(type_, CreatePeopleTimeoffType.list(), "type_")
        self.start_date = start_date
        self.end_date = end_date
        self.reason = reason
        if attachments is not None:
            self.attachments = attachments
