# This file was generated by liblab | https://liblab.com/

from __future__ import annotations
from enum import Enum
from typing import List
from .utils.json_map import JsonMap
from .base import BaseModel
from .timesheet_id_items import TimesheetIdItems, TimesheetIdItemsGuard


class TimesheetReviewsToCreateStatus(Enum):
    """An enumeration representing different categories.

    :cvar APPROVED: "approved"
    :vartype APPROVED: str
    :cvar DECLINED: "declined"
    :vartype DECLINED: str
    """

    APPROVED = "approved"
    DECLINED = "declined"

    def list():
        """Lists all category values.

        :return: A list of all category values.
        :rtype: list
        """
        return list(
            map(lambda x: x.value, TimesheetReviewsToCreateStatus._member_map_.values())
        )


@JsonMap({})
class TimesheetReviewsToCreate(BaseModel):
    """TimesheetReviewsToCreate

    :param status: status
    :type status: TimesheetReviewsToCreateStatus
    :param reason: reason, defaults to None
    :type reason: str, optional
    :param ids: ids
    :type ids: List[TimesheetIdItems]
    """

    def __init__(
        self,
        status: TimesheetReviewsToCreateStatus,
        ids: List[TimesheetIdItems],
        reason: str = None,
    ):
        self.status = self._enum_matching(
            status, TimesheetReviewsToCreateStatus.list(), "status"
        )
        if reason is not None:
            self.reason = reason
        self.ids = self._define_list(ids, TimesheetIdItems)
